import 'dart:async';

import 'package:craba/craba.dart';

import 'package:test/test.dart';

void main() {
  test('craba', () async {
    Craba? c0, c1;
    c0 = Craba((message) async {
      print(message);
      await c1?.receive(message);
    });
    c1 = Craba((message) async {
      print(message);
      await c0?.receive(message);
    });
    config(c0);
    config(c1);
    final r0 = await c0.deliver('ping');
    print(r0);
    final r1 = await c1.deliver(
      'download',
      param: 'path',
      onNotify: (param) async {
        print(param);
      },
    );
    print(r1);
    expect(r0, 'pong');
    expect(r1, 'path');
  });
}

void config(Craba craba) {
  craba.on('ping', (param, cancelable, notify) async {
    return 'pong';
  });
  craba.on('download', (param, cancelable, notify) async {
    StreamSubscription? sub = null;
    Timer? timer = null;
    final completer = Completer<String>();
    var i = 0;
    timer = Timer.periodic(Duration(seconds: 1), (timer) async {
      i++;
      if (i < 10) {
        notify('${i}/10');
        return;
      }
      if (completer.isCompleted) {
        return;
      }
      timer.cancel();
      await sub?.cancel();
      completer.complete(param);
    });
    cancelable.whenCancel(() {
      if (completer.isCompleted) {
        return;
      }
      timer?.cancel();
      completer.completeError('cancelled');
    });
    final r = await completer.future;
    return r;
  });
}
